#include "ds18x20lib.h"
#include <stdio.h>
#define F_CPU 8000000
#include <util/delay.h>

#define LED_DDRA DDRA				//DDR  fr die LED Anzeige
#define LED_DDRB DDRB				//DDR  fr die LED Anzeige
#define LED_DDRD DDRD				//DDR  fr die LED Anzeige
#define LED_OUTA PORTA				//PORT fr die LED Anzeige
#define LED_OUTB PORTB				//PORT fr die LED Anzeige
#define LED_OUTD PORTD				//PORT fr die LED Anzeige

uint8_t bcd2bin( uint8_t val )
{
  uint8_t  hilf = val;
  return (hilf & 0x0F) + (hilf >> 4) * 10;
} 


int main (void)
{
	
	unsigned char temp_pc0_str[8],temp_pc1_str[8],temp_pc2_str[8],temp_pc3_str[8],temp_pc4_str[8];
	float temp_pc0,temp_pc1,temp_pc2,temp_pc3,temp_pc4;
	const uint16_t pause = 1000;

	int8_t p;
	int8_t pp;
	int8_t ppp;
    int16_t t;
	int8_t t_ist =0;
	int8_t tt_ist =0;
	int8_t ttt_ist =0;
	int8_t aa = 0b00000000;
	int8_t bb = 0b11111111;

	ds1820_init(DS1820_pin_pc0);              //Initialisiere DS1820 PC0
	ds1820_init(DS1820_pin_pc1);              //Initialisiere DS1820 PC1
	ds1820_init(DS1820_pin_pc2);              //Initialisiere DS1820 PC2
	ds1820_init(DS1820_pin_pc3);              //Initialisiere DS1820 PC3
	ds1820_init(DS1820_pin_pc4);              //Initialisiere DS1820 PC4
	
	DDRA  = 0xff;							  //alle B Port Pins sind Output
	DDRB  = 0xff;                             //alle B Port Pins sind Output
	DDRD  = 0xff;                             //alle B Port Pins sind Output
    PORTA = 0x00; 						      //fangen alle bei 0V an	
    PORTB = 0x00; 						      //fangen alle bei 0V an	
    PORTD = 0x00; 						      //fangen alle bei 0V an
	
	// Initialisierung der LED (Prfen ob alle leuchten)
    for(int a=0; a<1; a++)
        {
			PORTA = aa;
			PORTB = aa;
			PORTD = aa;
			for(int a=0; a<1; a++){ _delay_ms(pause);}
            PORTA = bb;
			PORTB = bb;
			PORTD = bb;
            for(int b=0; b<1; b++){ _delay_ms(pause);}
		}
		
	do{
		
		
		

    	temp_pc0 = ds1820_read_temp(DS1820_pin_pc0);//Temperatur vom DS1820 an PC0
		temp_pc1 = ds1820_read_temp(DS1820_pin_pc1);//Temperatur vom DS1820 an PC1
		temp_pc2 = ds1820_read_temp(DS1820_pin_pc2);//Temperatur vom DS1820 an PC2
		temp_pc3 = ds1820_read_temp(DS1820_pin_pc3);//Temperatur vom DS1820 an PC3
		temp_pc4 = ds1820_read_temp(DS1820_pin_pc4);//Temperatur vom DS1820 an PC4

		p   = 0x00;
		pp  = 0x00;
		ppp = 0x00;
		
		//von float in int konvertieren (Kommastelle weg schneiden)
		p   = temp_pc0;
		pp  = temp_pc1;
		ppp = temp_pc2;
		
		// von Binr in Binary Coded Decimal konvertieren
		t_ist   = bcd2bin ( p );
		tt_ist  = bcd2bin ( pp );
		ttt_ist = bcd2bin ( ppp );

		//p = p-0,5;				//evtl Eichung des Thermometers
				
		LED_OUTD = ~t_ist;		//LED Signal invertieren weil LED falsch angeltet
		LED_OUTA = ~tt_ist;		//LED Signal invertieren weil LED falsch angeltet
		LED_OUTB = ~ttt_ist;	//LED Signal invertieren weil LED falsch angeltet

	}while(1);
	
}

